var climbing_time;//ローレーションピリオドの長さ
var remain;//ローレーションピリオドの残り時間
var passed=0;//ローレーションピリオドの経過時間

var sb_mode;//計時中のモード（スタートボタンの表示文字列）
			//0=動作待ち（START）1=計時中（STOP）
			
var op_mode;//設定中(boolean)			
var cd_=5;//カウントダウンを何秒前から始めるか
var round;//予選/準決勝＝0、コンテスト＝1、決勝＝2、オブザベーション＝3

var inci=false;//インシデントボタンの表示が残り時間
var soundOk;//音を鳴らす(boolean)	
var soundTweak;//音が出るタイミングを早める

var sound_;//1分前をならした

var cd_counter;

var exWin;//外部ディスプレイ表示用の新規ウィンドウ
var useEx;//外部ディスプレイの使用

var clr="y";

var interval=15;
var mode=0;//0:通常計時、1:インターバル中

var timeLst=new Array("<option value='120'>計測時間　&rArr;　2分</option>",
					"<option value='180'>計測時間　&rArr;　3分</option>",
					"<option value='240'>計測時間　&rArr;　4分</option>",
					"<option value='300' >計測時間　&rArr;　5分</option>",
					"<option value='360'>計測時間　&rArr;　6分</option>",
					"<option value='600'>計測時間　&rArr;　10分</option>",
					"<option value='900'>計測時間　&rArr;　15分</option>",
					"<option value='1200'>計測時間　&rArr;　20分</option>",
					"<option value='1800'>計測時間　&rArr;　30分</option>",
					"<option value='2100'>計測時間　&rArr;　35分</option>",
					"<option value='2400'>計測時間　&rArr;　40分</option>",
					"<option value='2700'>計測時間　&rArr;　45分</option>",
					"<option value='3000'>計測時間　&rArr;　50分</option>",
					"<option value='3600'>計測時間　&rArr;　60分</option>",
					"<option value='3900'>計測時間　&rArr;　65分</option>",
					"<option value='4200'>計測時間　&rArr;　70分</option>",
					"<option value='4800'>計測時間　&rArr;　80分</option>",
					"<option value='5400'>計測時間　&rArr;　90分</option>",
					"<option value='6000'>計測時間　&rArr;　100分</option>",
					"<option value='6600'>計測時間　&rArr;　110分</option>",
					"<option value='7200'>計測時間　&rArr;　120分</option>",
					"<option value='7800'>計測時間　&rArr;　130分</option>",
					"<option value='8400'>計測時間　&rArr;　140分</option>",
					"<option value='9000'>計測時間　&rArr;　150分</option>");

$(document).ready(function(){
	all_reset();
	//表示されているウィンドウのサイズから、各エレメントのサイズを決定
	sizeSet();

	//念のため初期化 スタートボタンの表示文字列でモードを判定
	
	chkSound();
	
	//設定モードを取得
	op_mode=getOpmode();

	//経過時間に数値以外が入っている場合、ゼロに初期化
	if(isNaN(passed)){passed=0;};

	//時間表示を書き換え
	round=chkMode()
	disp_num();
	
	
	//設定ボタンを初期化
	$("input[name='o_btn']").button("enable").button("refresh");

	//右手用、左手用設定確認
	//chkHand();
	
	//音を出すタイミングを早めるかどうか
	getTweak()	

	//ヘッダー文字列の設定
	setTitle();

//以下はイベント発生時

	//windowサイズ変更時	
	$( window ).resize(function(){
		sizeSet();
	});
	
	//音を鳴らすかどうか
	$("#usesound").change(function(event){
 	  	chkSound();
	});
	
		//計測時間の変更
	$("#tweak").on("change",function(){
 		sound("sound");
		getTweak();
			sizeSet();	
		$(".timebox").css("color","yellow")

	});

	//ラウンドの変更（予選/準決勝、決勝、オブザベーション、）
	$("#c_type").change(function(){
//	$("input[name='round']:radio").change(function(){
		sound("sound");
		round=chkMode();
		disp_num();
			sizeSet();	
		$(".timebox").css("color","yellow")

	});

	//インターバルの変更
	$("#interval").change(function(){
		sound("sound");
		interval=$("#interval").val();
        	sizeSet();	
		$(".timebox").css("color","yellow")

	});

	//計測時間の変更
	$("#c_time").on("change",function(){
 		sound("sound");
 		passed=0;
		setTime();
	sizeSet();	
		$(".timebox").css("color","yellow")
		
	});

	//ヘッダーの変更
	$("#round").on("change",function(){
		setTitle()
	});
	$("#round").on("keyup",function(){
		setTitle()
	});

	//設定ボタンのクリック
	$("#o_btn").on("mousedown",function(){
		sound("sound");
 		o_btn_clk();
		$(".timebox").css("color","yellow")

	});

	
	document.onkeydown = function(e) {
		var keyCode = false;

		if (e) event = e;

		if (event) {
			if (event.keyCode) {
				keyCode = event.keyCode;
			} else if (event.which) {
				keyCode = event.which;
			}
		}

	if(getOpmode()==true){	

		
		switch(keyCode){
			case 13://Key[Enter]
		 		sound("sound");
		$(".timebox").css("color","yellow")
				start();
	 	 		break;
				
			case 27://esc
			case 8:
				if(sb_mode==0){
				sound("sound");
				o_btn_clk();
				exFullscreen()
				};
			

	 	 		break;
				
			case 32://backspace
				if(round!=3 && sb_mode!=0){incident()};
	 	 		break;
			default:
				break;
		};
	};
	};
});

function incident(){

 		if(inci==false){
			inci=true;
			$("#i_btn").css("display","block");
			i_occur=new Date();
			$("#header_title").html("テクニカルインシデント発生");
			$("#i_btn").html("時刻："+i_occur.getHours()+"時"+i_occur.getMinutes()+"分"+i_occur.getSeconds()+"秒 / "+$("#timebox_p").text());
			
			//$("#timebox_p").text());
			}
		else{
			inci=false;
			$("#i_btn").html("");
			$("#i_btn").css("display","none");
			setTitle();
		};


};


function exFullscreen(){

if (document.fullscreenElement) {
    document.exitFullscreen()
      .then(() => console.log("Document Exited form Full screen mode"))
      .catch((err) => console.error(err))
  }
};

function o_btn_clk(){

	if(getOpmode()==true){
		$("#timer_box").css("display","none");
		$("#setting_box").css("display","block");
		$("#o_btn").val("計時画面へ");
		$("#s_box").css("display","none");
		$("#i_box").css("display","none");
		$("#timebox_p").css("display","none");

		document.getElementById("o_btn").previousSibling.textContent=$("#o_btn").val(); 
		$("#timer_rap").css("background-color","white");
		}
	else {
		$("#timer_box").css("display","block");
		$("#setting_box").css("display","none");
		all_reset();

		$("#o_btn").val('設定画面へ');
		//round=chkRnd();
		$("#s_box").css("display","table-cell");
		$("#i_box").css("display","table-cell");
		$("#timebox_p").css("display","block");
		document.getElementById("o_btn").previousSibling.textContent=$("#o_btn").val();   
		$("#timer_rap").css("background-color","black");
		document.body.requestFullscreen();
	};
};

//設定モードを取得
function getOpmode(){
	if($("#o_btn").val()=="設定画面へ"){return true}
	else
	{return false};
};

//音を出すタイミング調整の取得
function getTweak(){
	soundTweak=parseInt($("#tweak").val());
};

//ヘッダータイトルの設定
function setTitle(){
	if($("#round").val()!=""){
		$("#header_title").text($("#round").val());
		}
	else
		{
		$("#header_title").text("Bouldering Timer");
	}
};

//計測時間の設定
function setTime(){
	//経過時間に数値以外が入っている場合、ゼロに初期化
	if(isNaN(passed)){passed=0;};

	//残り時間を取得
	climbing_time=parseInt($("#c_time").val())-passed;
	remain=climbing_time;
	//時間表示を書き換え
	disp_num();
};

function timeList(rnd){
	$("#c_time").empty();
	
	if(rnd==1){
		tmp1=5;
		tmp2=timeLst.length
		}
	else
	{
		tmp1=0;
		tmp2=4
		};
	for(var i = tmp1; i <=tmp2; i++) {
		$("#c_time").append(timeLst[i]);
	};
};

function chkRnd(){
	tmp=$("#c_type").val();
	switch (tmp) {
  		case "0"://予選/準決勝
			temp=0;
    			break;
  		case "1"://コンテスト
			temp=1;
    			break;
  		case "2"://決勝
			temp=2;
    			break;
  		case "3"://決勝オブザベーション
			temp=3;
    			break;

  		default:
			temp=0;
		};
	alert($("#c_time").val());

};

//ラウンドの切り替え
function chkMode(){

	passed=0;
	setTime();

	tmp=$("#c_type").val();
	switch (tmp) {
  		case "0"://予選/準決勝
			temp=0;
			tmp_b="300";
 			$("#interval").css("display","block")
  			$("#interval-button").css("display","block");
   			break;
  		case "1"://コンテスト
			temp=1;
			tmp_b="5400";
			$("#interval").css("display","none")
  			$("#interval-button").css("display","none");
    			break;
  		case "2"://決勝
			temp=2;
			tmp_b="240";
 			$("#interval").css("display","none")
  			$("#interval-button").css("display","none");
   			break;
  		case "3"://決勝オブザベーション
			temp=3;
			tmp_b="120";
 			$("#interval").css("display","none")
  			$("#interval-button").css("display","none");
   			break;

  		default:
			temp=0;
			tmp_b="300";
			
	disp_num();

	return temp

}

	timeList(temp);
	$("#c_time").val(tmp_b).selectmenu('refresh');
	remain=tmp_b;
	disp_num();

	return temp
};

//音を鳴らすかどうか

function chkSound(){
	if($("#usesound").prop('checked')){
		soundOk=true
		sound("sound");
		$("#tweak-button").css("visibility","visible");
	}
	else	{
		soundOk= false
		$("#tweak-button").css("visibility","hidden");
	};
};

//スタートボタンのクリック時
function start(){
//クリック時の計時モードで選択
	switch(sb_mode){
		case 0://初期状態

			sb_mode=1;
	 		if(round==0){mode=0};

			$("input[name='round']:radio").checkboxradio("disable").checkboxradio("refresh");
			$("#c_time").selectmenu("disable").selectmenu("refresh");
			$("input[id='o_btn']").button("disable").button("refresh");
				
			sound_=false;
			
			tmppassed=0;

			if(round!=3){
				remain=cd_;
				disp_num()

				starttime=getNow();
				sb_mode=2;

				cd_counter=3;
				countdown()}
			else{
				climbing_time=parseInt($("#c_time").val());
				remain=climbing_time;

				passed=0;
				starttime=getNow();
				//経過時間をゼロに　現在時刻を計測開始時刻にセット
				sb_mode=1;

				timer_main();
				};
			break;

		case 1://計時中
			clearTimeout();

			all_reset();

			break;
			
		case 2://カウントダウン中
			sb_mode=0;
	}
};

function countdown(){
	tmpremain=cd_-parseInt(getNow()-starttime);
	//経過時間を取得
	
	if (tmpremain<=remain && remain>0){
		//残り時間を1減して時間表示
		remain=tmpremain;
		console.log("countdown")

		sound("countdown");
		$(".timebox").css("color","#aaff33")
		
		disp_num();
	
	};
	
	if(remain==0){
		//cd_counter=3;
		clearTimeout()
		climbing_time=parseInt($("#c_time").val());
		
		remain=climbing_time;

		passed=0;
		starttime=getNow();
		//経過時間をゼロに　現在時刻を計測開始時刻にセット
		sound_=false;
		sb_mode=1;
		sound("timeup");
		$(".timebox").css("color","yellow")
		timer_main();
	}
	else
	{
		if(sb_mode==2){
			setTimeout("countdown()",50)}
		else{
			clearTimeout();
			all_reset();
		};
	};
};

function timer_main(){
	
	tmppassed=parseInt(getNow()-starttime);
	//経過時間を取得
	
	if (tmppassed>passed){
		//残り時間を1減して時間表示
		passed=tmppassed;
		
		remain=climbing_time-passed;
	};
	//予選/準決勝＝0、コンテスト＝1、決勝＝2、オブザベーション＝3

		
	if(passed==climbing_time-soundTweak){
		  sound("timeup");
	};
	
	if(passed>=climbing_time-soundTweak-cd_){
		  sound("countdown");
	};
	
	if(round!=3 && passed==climbing_time-soundTweak-60 && sound_==false){
		  sound("minute");
		  sound_=true;
	};
		
	if(passed==climbing_time){//残り時間0
		if(round!=0){//予選準決勝以外
				clearTimeout();
				all_reset()
				}
		else{//予選準決勝では
			if(mode==0){//通常計時なら
				mode=1;
				climbing_time=interval;
				$(".timebox").css("color","#aaff33")

			}else{//インターバル計時なら
				mode=0;
				climbing_time=parseInt($("#c_time").val());
				$(".timebox").css("color","yellow")

			};

			remain=climbing_time
			passed=0;
			starttime=getNow();
		//経過時間をゼロに　現在時刻を計測開始時刻にセット
			sound_=false;
			setTimeout("timer_main()",50)
			};
	}
	else
	{//残り時間あり

		if(sb_mode==1){
			setTimeout("timer_main()",50)
		}else{
			sb_mode==0
			clearTimeout()
			all_reset()
		};

	};
			disp_num()

};

//残り時間と経過時間を表示/書き換え
function disp_num(){

//経過時間
	tmpsec=passed%60;
		tmpmin=Math.floor(passed/60);
		tmpstr=futaketa(tmpmin)+":"+futaketa(tmpsec);
//オブザベーション終了時の表示をととのえる

	$("#timebox_p").html("経過時間："+tmpstr);

	var	tmphour=Math.floor(remain/3600);

		if(tmphour>0){
			$("#h").text(tmphour%10);
			}else{
			$("#h").text(0);
				};
	
	tmpsec=remain%60;

		tmpmin=Math.floor(remain/60);
		if(tmpmin>9){
			$("#m1").text(Math.floor(tmpmin/10));
			}else{
			$("#m1").text(0);
				};
		$("#m2").text(tmpmin%10);

	tmp=tmpmin%60;
		if(tmp>9){
			$("#m1").text(Math.floor(tmp/10));
			}else{
			$("#m1").text(0);
				};
		$("#m2").text(tmp%10);

		if(tmpsec>9){
			$("#s1").text(Math.floor(tmpsec/10));
			}else{
			$("#s1").text(0);
				};
		$("#s2").text(tmpsec%10);


//		tmpstr=futaketa(tmpmin)+":"+futaketa(tmpsec);


//	$("#timebox_r").text(tmpstr);
	
	
};

function blackNum(){
	//$("#timebox_p").css("color","black");
	//$("#timebox_r").css("color","black");
};

function getNow(){
	my_start=new Date();

	return my_start.getTime()/1000;
};

function miketa(num){
	if(parseInt(num)>59){
		tmpm=num%60;
		tmph=Math.floor(num/60);
		num=tmph+":"+tmpm;
	}
	else
	{
	if (parseInt(num)<10){
		num=0+num.toString();
	}
	};
	return num;
};

function futaketa(num){
	if (parseInt(num)<10){
		num=0+num.toString();
	};
	return num;
};

function all_reset(){
	mode=0;
	sb_mode=0;
	$(".timebox").css("color","yellow")
	
	$("c_type").val("0").selectmenu("refresh");
	$("#c_time").selectmenu("enable").selectmenu("refresh");
	$("input[id='o_btn']").button("enable").button("refresh");
	$("#round").removeAttr("disabled");
	$("#c_time").removeAttr("disabled");
	
	
	$("#i_btn").html("");
   	
	setTitle();
	
	passed=0;
	setTime();
	disp_num();
};

	
function sizeSet(){
//ウィンドウの縦横のサイズを取得し、それをもとに各エレメントのベースとなるサイズを決定
	var miniHeight;
	var dummyHeight;//dummyboxの高さ
	var dummyWidth;//dummyboxの幅
	var baseSize;//各エレメントのサイズの基準値

	var winHeight = $(window).height();
	var winWidth = $(window).width();
	
//		miniHeight =400;
	//	windowの高さの75%をdummyboxの高さにする
	dummyHeight=winHeight*0.9;
		
			
	//if(dummyHeight<miniHeight){dummyHeight=miniHeight;};
	
//	$("#dummybox").css("height",dummyHeight+"px");
	//if(winHeight<winWidth){
	dummyWidth=dummyHeight*72/100;
	//}
//	else
//	{dummyWidth=dummyHeight*70/100};
	
	//dummyboxの幅をdummyboxの高さの33/45にする

	$("#dummybox").css("width",dummyWidth+"px");

	baseSize=dummyWidth;

	bairitsu=baseSize/320;
//以下、各エレメントのサイズを設定
	//$("#dummybox").css("padding",20*bairitsu+"px 0");
	$("input").css("font-size",Math.round(15*bairitsu)+"px")

	$("select").css("font-size",Math.round(13*bairitsu)+"px")
	$("td").css("font-size",Math.round(13*bairitsu)+"px");
	$("label").css("font-size",Math.round(13*bairitsu)+"px");
	$("h1").css("font-size",Math.round(22*bairitsu)+"px");
	$("h2").css("font-size",Math.round(14*bairitsu)+"px");
	$(".option_item").css("font-size",Math.round(14*bairitsu)+"px");
	$("h3").css("font-size",Math.round(13*bairitsu)+"px");
	$("hr").css("padding","0 0 "+Math.round(2*bairitsu)+"px 0");

	if($("#c_time").val()>3600){
				$("#h").css("display","table-cell");
			$("#c1").css("display","table-cell");
	$(".timebox").css("font-size",Math.round(winWidth*0.28)+"px")}else{
					$("#h").css("display","none");
			$("#c1").css("display","none");

		$(".timebox").css("font-size",Math.round(winWidth/3)+"px")};
	

	$(".l_button").css({"font-size":Math.round(30*bairitsu)+"px","border-width":Math.round(4*bairitsu)+"px"})
	
	$(".s_button").css({"height":Math.round(60*bairitsu)+"px","font-size":Math.round(18*bairitsu)+"px"})
	$(".time_disp").css({"border-width":Math.round(5*bairitsu)+"px","padding-top":Math.round(15*bairitsu)+"px"});
	
	$(".caption").css("font-size",Math.round(16*bairitsu)+"px");
	$(".setting_p").css("font-size",Math.floor(11*bairitsu)+"px");
	$(".cent").css("margin",Math.floor(6*bairitsu)+"px auto");

	$(".cbox").css({"width":Math.round(18*bairitsu)+"px","height":Math.round(18*bairitsu)+"px","padding-left":Math.round(5*bairitsu)+"px","top":Math.round(4*bairitsu)+"px"})
	document.getElementById("tweak").parentNode.style.fontSize=(Math.floor(15*bairitsu)+"px");
	document.getElementById("o_btn").parentNode.style.fontSize=(Math.floor(15*bairitsu)+"px");
//	$("#s_btn").css({"font-size":Math.floor(18*bairitsu)+"px"});
	$("#i_btn").css({"font-size":Math.floor(18*bairitsu)+"px"});

	$("#r_btn").css({"font-size":Math.floor(20*bairitsu)+"px","height":Math.floor(75*bairitsu)+"px"});
	$("#round").css("font-size",Math.floor(15*bairitsu)+"px");
	$("#c_time-button").css("font-size",Math.floor(15*bairitsu)+"px");
	$("#c_type-button").css("font-size",Math.floor(15*bairitsu)+"px");
	$("#interval-button").css("font-size",Math.floor(15*bairitsu)+"px");

	$("#setting_box").css("width",Math.floor(300*bairitsu)+"px");

	if(winWidth>winHeight/(16/8)){tmp=winWidth/35}else{tmp=winWidth/30};

//	document.getElementById("s_btn").parentNode.style.fontSize=(Math.floor(tmp*1.2)+"px");

	$("#i_btn").css("font-size",Math.floor(tmp)+"px");
	$("#setting_box").css("width",Math.floor(300*bairitsu)+"px");

	$("#o_btn").css(Math.floor(tmp)+"px");

	$("#p_box").css("font-size",Math.round(tmp)+"px");
	$("#timebox_p").css("font-size",Math.round(tmp)+"px");


};

